"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CodeEditor = void 0;
require("codemirror/addon/dialog/dialog.css");
require("codemirror/addon/scroll/simplescrollbars.css");
// CodeMirror CSS
require("codemirror/lib/codemirror.css");
require("codemirror/theme/bespin.css");
const React = __importStar(require("react"));
const app_1 = require("../app");
const helpers_1 = require("../helpers");
const Wrapper = app_1.styled.div `
  .scrubbing {
    background: yellow;
  }

  .cm-number {
    border: 1px dashed rgba(0, 0, 0, 0);
    &.scrub {
      border: 1px dashed yellow;
      border-radius: 4px;
      cursor: move;
    }
  }

  .CodeMirror-overlayscroll-horizontal div,
  .CodeMirror-overlayscroll-vertical div {
    background: #333;
  }

  .CodeMirror {
    padding: 10px;
    min-height: 1rem;
    height: auto;
  }

  .CodeMirror-code {
    font-size: 1rem;
  }

  .CodeMirror-linewidget {
    background: #353030;
    border-top: 1px dashed #899266;
    color: #959663;
    left: -1px;
    margin-top: 4px;
    padding: 4px;
    padding-left: 0px;
    width: 460px;
  }
`;
class CodeEditor extends React.Component {
    create(el) {
        const { props } = this;
        if (this.cm === undefined) {
            const onSave = (filename, source) => {
                this.props.onChange(source);
            };
            const typecheck = (filename, source) => {
                // not used for now
                // this.props.typecheck({ filename, source })
            };
            const id = props.id;
            this.cm = false;
            setTimeout(() => {
                this.cm = helpers_1.makeEditor(el, props.source || '', props.lang || 'ts', {
                    onSave,
                    onBlur: props.onBlur,
                    typecheck,
                }, { autofocus: props.focus, keyMap: props.keyMap });
                // FIXME: source changed (compile)
                helpers_1.sourceChanged(this.cm, props.lang, props.source, {
                    id,
                });
                // FIXME: focus...
            }, 100);
        }
    }
    render() {
        const { props } = this;
        if (this.cm) {
            /*
              const errors = this.props.errors
              this.cm.operation
              ( () => {
                  const doc = cm.getDoc ()
                  for ( const v of ederror ) {
                    doc.removeLineWidget ( v )
                  }
                  ederror.length = 0
                  showErrors ( errors )
                }
              )
              */
        }
        if (this.cm) {
            const id = props.id;
            helpers_1.sourceChanged(this.cm, props.lang, props.source, { id });
        }
        return (React.createElement(Wrapper, { className: this.props.className, onClick: e => e.stopPropagation() },
            React.createElement("div", { className: "codeholder", ref: el => this.create(el) })));
    }
}
exports.CodeEditor = CodeEditor;
//# sourceMappingURL=CodeEditor.js.map